/*
 * Copyright (c) 2011-2014 BlackBerry Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import bb.cascades 1.3
import bb.data 1.0
import bb.system 1.0
import Flashlight 1.0
import QTimer 1.0



TabbedPane {
    showTabsOnActionBar: true
    property int dosazenycas;
    
    Tab {
        Page {
            property int poradi;
            titleBar: TitleBar {
                title: qsTr("Stay visible") + Retranslate.onLocaleOrLanguageChanged
                appearance: TitleBarAppearance.Branded
            
            }     
            //property string vybrano;
            content: Container {
                id: cnMain
                property real margins: ui.du(3)
                
                
                topPadding: margins
                leftPadding: margins
                rightPadding: margins
                bottomPadding: margins                                
                
                
                attachedObjects: [
                    
                    
                    Flashlight {
                        id: flMain
                    },
                    QTimer {
                    id: cTimer
                    interval: 1000
                    singleShot: false
                    onTimeout: {
                         flMain.enabled =! flMain.enabled
                         console.log("Sviti>"+flMain.enabled);
                         console.log("Minut>"+slMinuty.value.toFixed(0))
                               }
                    },
                    QTimer {
                        id: c2Timer
                        interval: 1000
                        singleShot: false
                        onTimeout: {
                            dosazenycas ++;
                            if (dosazenycas * 1000 >= slMinuty.value.toFixed(0)*1000*60 ) 
                            {
                                btPlay.enabled = true;
                                btStop.enabled = false;
                                ddFrekvence.enabled = true;
                                slMinuty.enabled = true;
                                aiPrehravani.stop()
                                flMain.enabled = false;
                                cTimer.stop();
                                c2Timer.stop();  
                            
                            }
                        }                     
                    },
                    SystemDialog {
                        id: aboutDialog
                        title: "Info"
                        body: "(c) YAMACO Software 2015 \n \n web: www.yamaco.cz \n email: yamaco@yamaco.cz"
                        cancelButton.label: ""
                    },
                    Invocation {
                        id: invoke
                        query: InvokeQuery {
                            mimeType: "text/html"
                            uri: "http://appworld.blackberry.com/webstore/vendor/91027/?lang=en&countrycode=CZ"
                            invokeActionId: "bb.action.OPEN"
                        }
                    }
                ]
                ScrollView {
                    Container {
                        
                        
                        Divider {
                        
                        }
                        Label {
                            id: lbSlider
                            text: qsTr("Time to flashing (min):") + Retranslate.onLocaleOrLanguageChanged
                            horizontalAlignment: HorizontalAlignment.Center
                        
                        }
                        Slider {
                            id: slMinuty
                            toValue: 30.0
                            fromValue: 0.0
                            onValueChanged: {
                                lbSlider.text = qsTr("Time to flashing (min, 0=unlimited): ") 
                                + Retranslate.onLocaleOrLanguageChanged + value.toFixed(0)
                            }
                        
                        }

                        Divider {

                        }
                        DropDown {
                            id: ddFrekvence
                            title: qsTr("Flashing frequency")+ Retranslate.onLocaleOrLanguageChanged
                            selectedIndex: 0
                            Option {text: qsTr("Slow") + Retranslate.onLanguageChanged}
                            Option {text: qsTr("Moderate") + Retranslate.onLanguageChanged}
                            Option {text: qsTr("Fast") + Retranslate.onLanguageChanged}
                            Option {text: qsTr("Very fast") + Retranslate.onLanguageChanged}
                        }
                        
                        Divider {
                        
                        }
                        ActivityIndicator {
                            id: aiPrehravani
                            horizontalAlignment: HorizontalAlignment.Center
                            visible: false
                            preferredWidth: 200.0
                            preferredHeight: 200.0
                        
                        }
                        
                        Divider {

                        }
                        Container {
                            horizontalAlignment: HorizontalAlignment.Fill
                            verticalAlignment: VerticalAlignment.Center
                            layout: DockLayout {
                            
                            }
                            
                            leftPadding: 50.0
                            rightPadding: 50.0
                            Button {
                                id: btPlay
                                imageSource: "asset:///images/ic_play.png"
                                horizontalAlignment: HorizontalAlignment.Left
                                preferredWidth: 150.0
                                onClicked: {
                                    app.save("Duration", slMinuty.value.toFixed(0));
                                    app.save("Speed", ddFrekvence.selectedIndex);
                                    
                                    btPlay.enabled = false;
                                    btStop.enabled = true;
                                    slMinuty.enabled = false;
                                    aiPrehravani.start();
                                    //flMain.enabled = true;
                                    ddFrekvence.enabled = false;
                                    if (ddFrekvence.selectedIndex == 0) {cTimer.interval = 1000};
                                    if (ddFrekvence.selectedIndex == 1) {cTimer.interval = 500};
                                    if (ddFrekvence.selectedIndex == 2) {cTimer.interval = 250};
                                    if (ddFrekvence.selectedIndex == 3) {cTimer.interval = 100};
                                    cTimer.start(cTimer.interval);
                                    if (slMinuty.value.toFixed(0) > 0) 
                                    {
                                      dosazenycas = 0; c2Timer.start();
                                    }
                                }
                                text: "Start"
                            
                            }
                            
                            Button {
                                id: btStop
                                imageSource: "asset:///images/ic_stop.png"
                                horizontalAlignment: HorizontalAlignment.Right
                                preferredWidth: 150.0
                                enabled: false
                                text: "Stop"
                                onClicked: {
                                    btPlay.enabled = true;
                                    btStop.enabled = false;
                                    slMinuty.enabled = true;
                                    ddFrekvence.enabled = true;
                                    aiPrehravani.stop()
                                    flMain.enabled = false;
                                    cTimer.stop();
                                    c2Timer.stop();
                                }
                            
                            }
                        
                        }
                    }
                
                } 
            onCreationCompleted: {
                slMinuty.value=app.read("Duration","0");
                ddFrekvence.selectedIndex=app.read("Speed","0");
            }
            }
            actions: [
                
                
                ActionItem {
                    title: qsTr("Info") + Retranslate.onLanguageChanged
                    imageSource: "asset:///images/ic_info.png"
                    ActionBar.placement: ActionBarPlacement.InOverflow
                    
                    onTriggered: {
                        aboutDialog.show()
                    }
                
                },
                ActionItem {
                    title: qsTr("More apps") + Retranslate.onLanguageChanged
                    imageSource: "asset:///images/ic_select_more.png"
                    ActionBar.placement: ActionBarPlacement.InOverflow
                    onTriggered: {
                        invoke.trigger("bb.action.OPEN")
                    }
                
                }
            
            ]
        
        }
    }

}
